/* A Bison parser, made by GNU Bison 1.875d.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with rc_yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum rc_yytokentype {
     EOL = 258,
     T_BEGIN = 259,
     T_END = 260,
     AND = 261,
     OR = 262,
     IF = 263,
     FI = 264,
     ELSE = 265,
     RULE = 266,
     DONE = 267,
     CALL = 268,
     STOP = 269,
     ADD = 270,
     REMOVE = 271,
     MODIFY = 272,
     IDENT = 273,
     STRING = 274,
     REGEX = 275,
     D_BEGIN = 276,
     T_MSGPART = 277,
     NOT = 278
   };
#endif
#define EOL 258
#define T_BEGIN 259
#define T_END 260
#define AND 261
#define OR 262
#define IF 263
#define FI 264
#define ELSE 265
#define RULE 266
#define DONE 267
#define CALL 268
#define STOP 269
#define ADD 270
#define REMOVE 271
#define MODIFY 272
#define IDENT 273
#define STRING 274
#define REGEX 275
#define D_BEGIN 276
#define T_MSGPART 277
#define NOT 278




/* Copy the first part of user declarations.  */
#line 1 "rcfile.y"

/*
   rcfile.y

   This file is part of GNU Anubis.
   Copyright (C) 2003, 2004 The Anubis Team.

   GNU Anubis is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   GNU Anubis is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Anubis; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   GNU Anubis is released under the GPL with the additional exemption that
   compiling, linking, and/or using OpenSSL is allowed.
*/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <stdlib.h>
#include <string.h>
#include <setjmp.h>	
#include "headers.h"
#include "extern.h"
#include "rcfile.h"

extern int rc_yylex (void);
int rc_yyerror (char *s);

static RC_SECTION *rc_section_create (char *, size_t, RC_STMT *);
static void rc_section_destroy (RC_SECTION **);
static void rc_section_print (RC_SECTION *);
static void rc_asgn_destroy (RC_ASGN *);
static void rc_bool_destroy (RC_BOOL *);
static void rc_level_print (int, char *);
static RC_NODE *rc_node_create (enum rc_node_type);
static void rc_node_destroy (RC_NODE *);
static void rc_node_print (RC_NODE *);
static void rc_rule_destroy (RC_RULE *);
static void rc_cond_destroy (RC_COND *);
static RC_STMT *rc_stmt_create (enum rc_stmt_type);
static void rc_stmt_destroy (RC_STMT *);
static void rc_stmt_list_destroy (RC_STMT *);
static void rc_stmt_print (RC_STMT *, int);
static int reg_modifier_add (int *, char *);
static int check_kw (char *ident, int *flags);
static int is_prog_allowed (void);
 
static RC_SECTION *rc_section;
static int debug_level;
static int error_count;
static int def_regex_modifier = R_POSIX;
static struct rc_secdef *rc_secdef;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 66 "rcfile.y"
typedef union YYSTYPE {
  char *string;
  RC_SECTION *section;
  RC_STMT *stmt;
  struct {
    RC_STMT *head;
    RC_STMT *tail;
  } stmtlist;
  RC_COND cond;
  RC_RULE rule;
  RC_NODE *node;
  RC_REGEX *regex;
  int num;
  struct {
    int part;
    RC_REGEX *key;
    char *string;
  } msgpart;
  RC_LOC loc;
  struct {
    size_t line;
    char *name;
  } begin_sec;
  ANUBIS_LIST *list;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 213 "y.tab.c"
# define rc_yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 225 "y.tab.c"

#if ! defined (rc_yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (rc_yyoverflow) || YYERROR_VERBOSE */


#if (! defined (rc_yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union rc_yyalloc
{
  short int rc_yyss;
  YYSTYPE rc_yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union rc_yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T rc_yyi;		\
	  for (rc_yyi = 0; rc_yyi < (Count); rc_yyi++)	\
	    (To)[rc_yyi] = (From)[rc_yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T rc_yynewbytes;						\
	YYCOPY (&rc_yyptr->Stack, Stack, rc_yysize);				\
	Stack = &rc_yyptr->Stack;						\
	rc_yynewbytes = rc_yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	rc_yyptr += rc_yynewbytes / sizeof (*rc_yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char rc_yysigned_char;
#else
   typedef short int rc_yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  10
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   174

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  30
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  36
/* YYNRULES -- Number of rules. */
#define YYNRULES  67
/* YYNRULES -- Number of states. */
#define YYNSTATES  113

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   278

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? rc_yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char rc_yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      24,    25,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    29,     2,
       2,    26,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    27,     2,    28,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char rc_yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    13,    15,    19,    22,
      23,    28,    31,    34,    36,    39,    41,    44,    47,    50,
      53,    56,    59,    62,    64,    66,    69,    71,    76,    83,
      85,    89,    93,    97,   100,   101,   103,   105,   109,   110,
     112,   115,   117,   119,   121,   126,   127,   131,   137,   139,
     142,   143,   145,   148,   150,   152,   154,   159,   163,   165,
     167,   169,   171,   174,   178,   181,   186,   190
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const rc_yysigned_char rc_yyrhs[] =
{
      31,     0,    -1,    32,    -1,    33,    -1,    32,    33,    -1,
      32,     1,    -1,     3,    -1,    34,    37,    36,    -1,    34,
      36,    -1,    -1,     4,    35,    63,     3,    -1,    21,     3,
      -1,     5,     3,    -1,    38,    -1,    37,    38,    -1,     3,
      -1,    39,     3,    -1,    43,     3,    -1,    60,     3,    -1,
      64,     3,    -1,    65,     3,    -1,     1,     3,    -1,    40,
      41,    -1,    18,    -1,    42,    -1,    41,    42,    -1,    63,
      -1,    57,    44,    37,    58,    -1,    57,    44,    37,    59,
      37,    58,    -1,    53,    -1,    24,    44,    25,    -1,    44,
       6,    44,    -1,    44,     7,    44,    -1,    23,    44,    -1,
      -1,    26,    -1,    51,    -1,    27,    63,    28,    -1,    -1,
      46,    -1,    22,    47,    -1,    46,    -1,    48,    -1,    48,
      -1,    54,    27,    63,    28,    -1,    -1,    27,    63,    28,
      -1,    49,    55,    45,    55,    63,    -1,    56,    -1,    54,
      56,    -1,    -1,    54,    -1,    29,    18,    -1,     8,    -1,
       9,    -1,    10,    -1,    61,     3,    37,    12,    -1,    62,
      55,    63,    -1,    11,    -1,    19,    -1,    18,    -1,    14,
      -1,    13,    63,    -1,    15,    49,    63,    -1,    16,    50,
      -1,    17,    50,    52,    63,    -1,    17,    50,    52,    -1,
      20,    54,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int rc_yyrline[] =
{
       0,   115,   115,   120,   124,   139,   151,   155,   159,   165,
     165,   173,   183,   186,   190,   207,   211,   212,   213,   214,
     215,   216,   225,   247,   253,   258,   265,   268,   275,   284,
     285,   289,   296,   303,   312,   313,   316,   322,   331,   335,
     338,   343,   346,   354,   365,   373,   376,   382,   392,   398,
     407,   410,   413,   419,   426,   429,   432,   440,   450,   457,
     458,   461,   473,   485,   497,   509,   521,   539
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const rc_yytname[] =
{
  "$end", "error", "$undefined", "EOL", "T_BEGIN", "T_END", "AND", "OR",
  "IF", "FI", "ELSE", "RULE", "DONE", "CALL", "STOP", "ADD", "REMOVE",
  "MODIFY", "IDENT", "STRING", "REGEX", "D_BEGIN", "T_MSGPART", "NOT",
  "'('", "')'", "'='", "'['", "']'", "':'", "$accept", "input", "seclist",
  "section", "begin", "@1", "end", "stmtlist", "stmt", "asgn_stmt",
  "keyword", "arglist", "arg", "cond_stmt", "cond", "meq", "key",
  "opt_key", "msgpart", "s_msgpart", "r_msgpart", "regex", "string_key",
  "expr", "modlist", "opt_modlist", "modifier", "if", "fi", "else",
  "rule_stmt", "rule_start", "rule", "string", "inst_stmt", "modf_stmt", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int rc_yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    40,    41,    61,    91,    93,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char rc_yyr1[] =
{
       0,    30,    31,    32,    32,    32,    33,    33,    33,    35,
      34,    34,    36,    37,    37,    38,    38,    38,    38,    38,
      38,    38,    39,    40,    41,    41,    42,    43,    43,    44,
      44,    44,    44,    44,    45,    45,    46,    46,    47,    47,
      48,    48,    49,    50,    51,    52,    52,    53,    54,    54,
      55,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      63,    64,    64,    64,    64,    64,    64,    65
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char rc_yyr2[] =
{
       0,     2,     1,     1,     2,     2,     1,     3,     2,     0,
       4,     2,     2,     1,     2,     1,     2,     2,     2,     2,
       2,     2,     2,     1,     1,     2,     1,     4,     6,     1,
       3,     3,     3,     2,     0,     1,     1,     3,     0,     1,
       2,     1,     1,     1,     4,     0,     3,     5,     1,     2,
       0,     1,     2,     1,     1,     1,     4,     3,     1,     1,
       1,     1,     2,     3,     2,     4,     3,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char rc_yydefact[] =
{
       0,     6,     9,     0,     0,     0,     3,     0,     0,    11,
       1,     5,     4,     0,    15,     0,    53,    58,     0,    61,
       0,     0,     0,    23,     0,     8,     0,    13,     0,     0,
       0,     0,     0,     0,    50,     0,     0,    60,    59,     0,
      21,    12,    62,    38,     0,     0,    41,    42,     0,    36,
       0,    48,    43,    64,    45,    67,     7,    14,    16,    22,
      24,    26,    17,     0,     0,     0,    50,    29,    18,     0,
      51,     0,    19,    20,    10,    39,    40,     0,    52,    63,
       0,    49,     0,    66,    25,    33,     0,     0,     0,     0,
      34,     0,    57,    37,     0,     0,    65,    30,    31,    32,
      54,    55,    27,     0,    35,    50,    56,    44,    46,     0,
       0,    28,    47
};

/* YYDEFGOTO[NTERM-NUM]. */
static const rc_yysigned_char rc_yydefgoto[] =
{
      -1,     4,     5,     6,     7,     8,    25,    26,    27,    28,
      29,    59,    60,    30,    65,   105,    46,    76,    47,    66,
      53,    49,    83,    67,    50,    71,    51,    31,   102,   103,
      32,    33,    34,    61,    35,    36
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -64
static const short int rc_yypact[] =
{
      24,   -64,   -64,     1,     8,    13,   -64,   100,     7,   -64,
     -64,   -64,   -64,    26,   -64,    35,   -64,   -64,     7,   -64,
      40,    40,    40,   -64,   -18,   -64,   100,   -64,    47,     7,
      54,   119,    56,    57,   -18,    58,    62,   -64,   -64,    65,
     -64,   -64,   -64,    -6,     7,    52,   -64,   -64,     7,   -64,
      -5,   -64,   -64,   -64,    44,   -18,   -64,   -64,   -64,     7,
     -64,   -64,   -64,   119,   119,    79,   -18,   -64,   -64,   154,
     -18,     7,   -64,   -64,   -64,   -64,   -64,    45,   -64,   -64,
       7,   -64,     7,     7,   -64,   -64,    12,   119,   119,    38,
      50,   118,   -64,   -64,    49,    51,   -64,   -64,   -64,    72,
     -64,   -64,   -64,   154,   -64,   -18,   -64,   -64,   -64,   136,
       7,   -64,   -64
};

/* YYPGOTO[NTERM-NUM].  */
static const rc_yysigned_char rc_yypgoto[] =
{
     -64,   -64,   -64,    76,   -64,   -64,    63,   -60,   -25,   -64,
     -64,   -64,    29,   -64,   -57,   -64,    48,   -64,    11,    78,
      82,   -64,   -64,   -64,   -22,   -63,   -35,   -64,    -9,   -64,
     -64,   -64,   -64,    -8,   -64,   -64
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -3
static const rc_yysigned_char rc_yytable[] =
{
      39,    57,    55,    90,     9,    89,    85,    86,    10,    91,
      42,    45,    70,    -2,    11,    81,     1,     2,    87,    88,
      81,    44,    80,    45,    45,    37,    38,     1,     2,    40,
      98,    99,    52,    52,     3,    81,    77,    97,    41,    13,
      79,    14,   110,   109,    70,     3,    16,   100,   101,    17,
      58,    18,    19,    20,    21,    22,    23,    62,    24,    68,
      69,    72,    43,    92,    57,    73,    57,    44,    74,    45,
      78,    82,    94,    93,    95,    96,   104,   107,    87,   108,
      13,    12,    14,    70,    57,    87,    88,    16,    84,    56,
      17,    75,    18,    19,    20,    21,    22,    23,    48,    24,
     111,    13,   112,    14,    54,    15,     0,     0,    16,     0,
       0,    17,     0,    18,    19,    20,    21,    22,    23,    13,
      24,    14,     0,     0,     0,     0,    16,     0,     0,    17,
     106,    18,    19,    20,    21,    22,    23,    13,    24,    14,
       0,    43,    63,    64,    16,   100,    44,    17,    45,    18,
      19,    20,    21,    22,    23,    13,    24,    14,     0,     0,
       0,     0,    16,     0,     0,    17,     0,    18,    19,    20,
      21,    22,    23,     0,    24
};

static const rc_yysigned_char rc_yycheck[] =
{
       8,    26,    24,    66,     3,    65,    63,    64,     0,    69,
      18,    29,    34,     0,     1,    50,     3,     4,     6,     7,
      55,    27,    27,    29,    29,    18,    19,     3,     4,     3,
      87,    88,    21,    22,    21,    70,    44,    25,     3,     1,
      48,     3,   105,   103,    66,    21,     8,     9,    10,    11,
       3,    13,    14,    15,    16,    17,    18,     3,    20,     3,
       3,     3,    22,    71,    89,     3,    91,    27,     3,    29,
      18,    27,    80,    28,    82,    83,    26,    28,     6,    28,
       1,     5,     3,   105,   109,     6,     7,     8,    59,    26,
      11,    43,    13,    14,    15,    16,    17,    18,    20,    20,
     109,     1,   110,     3,    22,     5,    -1,    -1,     8,    -1,
      -1,    11,    -1,    13,    14,    15,    16,    17,    18,     1,
      20,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
      12,    13,    14,    15,    16,    17,    18,     1,    20,     3,
      -1,    22,    23,    24,     8,     9,    27,    11,    29,    13,
      14,    15,    16,    17,    18,     1,    20,     3,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    13,    14,    15,
      16,    17,    18,    -1,    20
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char rc_yystos[] =
{
       0,     3,     4,    21,    31,    32,    33,    34,    35,     3,
       0,     1,    33,     1,     3,     5,     8,    11,    13,    14,
      15,    16,    17,    18,    20,    36,    37,    38,    39,    40,
      43,    57,    60,    61,    62,    64,    65,    18,    19,    63,
       3,     3,    63,    22,    27,    29,    46,    48,    49,    51,
      54,    56,    48,    50,    50,    54,    36,    38,     3,    41,
      42,    63,     3,    23,    24,    44,    49,    53,     3,     3,
      54,    55,     3,     3,     3,    46,    47,    63,    18,    63,
      27,    56,    27,    52,    42,    44,    44,     6,     7,    37,
      55,    37,    63,    28,    63,    63,    63,    25,    44,    44,
       9,    10,    58,    59,    26,    45,    12,    28,    28,    37,
      55,    58,    63
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define rc_yyerrok		(rc_yyerrstatus = 0)
#define rc_yyclearin	(rc_yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto rc_yyacceptlab
#define YYABORT		goto rc_yyabortlab
#define YYERROR		goto rc_yyerrorlab


/* Like YYERROR except do call rc_yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto rc_yyerrlab

#define YYRECOVERING()  (!!rc_yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (rc_yychar == YYEMPTY && rc_yylen == 1)				\
    {								\
      rc_yychar = (Token);						\
      rc_yylval = (Value);						\
      rc_yytoken = YYTRANSLATE (rc_yychar);				\
      YYPOPSTACK;						\
      goto rc_yybackup;						\
    }								\
  else								\
    { 								\
      rc_yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `rc_yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX rc_yylex (YYLEX_PARAM)
#else
# define YYLEX rc_yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (rc_yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (rc_yydebug)					\
    rc_yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (rc_yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      rc_yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| rc_yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
rc_yy_stack_print (short int *bottom, short int *top)
#else
static void
rc_yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (rc_yydebug)							\
    rc_yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
rc_yy_reduce_print (int rc_yyrule)
#else
static void
rc_yy_reduce_print (rc_yyrule)
    int rc_yyrule;
#endif
{
  int rc_yyi;
  unsigned int rc_yylno = rc_yyrline[rc_yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             rc_yyrule - 1, rc_yylno);
  /* Print the symbols being reduced, and their result.  */
  for (rc_yyi = rc_yyprhs[rc_yyrule]; 0 <= rc_yyrhs[rc_yyi]; rc_yyi++)
    YYFPRINTF (stderr, "%s ", rc_yytname [rc_yyrhs[rc_yyi]]);
  YYFPRINTF (stderr, "-> %s\n", rc_yytname [rc_yyr1[rc_yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (rc_yydebug)				\
    rc_yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int rc_yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef rc_yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define rc_yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
rc_yystrlen (const char *rc_yystr)
#   else
rc_yystrlen (rc_yystr)
     const char *rc_yystr;
#   endif
{
  register const char *rc_yys = rc_yystr;

  while (*rc_yys++ != '\0')
    continue;

  return rc_yys - rc_yystr - 1;
}
#  endif
# endif

# ifndef rc_yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define rc_yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
rc_yystpcpy (char *rc_yydest, const char *rc_yysrc)
#   else
rc_yystpcpy (rc_yydest, rc_yysrc)
     char *rc_yydest;
     const char *rc_yysrc;
#   endif
{
  register char *rc_yyd = rc_yydest;
  register const char *rc_yys = rc_yysrc;

  while ((*rc_yyd++ = *rc_yys++) != '\0')
    continue;

  return rc_yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
rc_yysymprint (FILE *rc_yyoutput, int rc_yytype, YYSTYPE *rc_yyvaluep)
#else
static void
rc_yysymprint (rc_yyoutput, rc_yytype, rc_yyvaluep)
    FILE *rc_yyoutput;
    int rc_yytype;
    YYSTYPE *rc_yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) rc_yyvaluep;

  if (rc_yytype < YYNTOKENS)
    {
      YYFPRINTF (rc_yyoutput, "token %s (", rc_yytname[rc_yytype]);
# ifdef YYPRINT
      YYPRINT (rc_yyoutput, rc_yytoknum[rc_yytype], *rc_yyvaluep);
# endif
    }
  else
    YYFPRINTF (rc_yyoutput, "nterm %s (", rc_yytname[rc_yytype]);

  switch (rc_yytype)
    {
      default:
        break;
    }
  YYFPRINTF (rc_yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
rc_yydestruct (int rc_yytype, YYSTYPE *rc_yyvaluep)
#else
static void
rc_yydestruct (rc_yytype, rc_yyvaluep)
    int rc_yytype;
    YYSTYPE *rc_yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) rc_yyvaluep;

  switch (rc_yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int rc_yyparse (void *YYPARSE_PARAM);
# else
int rc_yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int rc_yyparse (void);
#else
int rc_yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int rc_yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE rc_yylval;

/* Number of syntax errors so far.  */
int rc_yynerrs;



/*----------.
| rc_yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int rc_yyparse (void *YYPARSE_PARAM)
# else
int rc_yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
rc_yyparse (void)
#else
int
rc_yyparse ()

#endif
#endif
{
  
  register int rc_yystate;
  register int rc_yyn;
  int rc_yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int rc_yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int rc_yytoken = 0;

  /* Three stacks and their tools:
     `rc_yyss': related to states,
     `rc_yyvs': related to semantic values,
     `rc_yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow rc_yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int rc_yyssa[YYINITDEPTH];
  short int *rc_yyss = rc_yyssa;
  register short int *rc_yyssp;

  /* The semantic value stack.  */
  YYSTYPE rc_yyvsa[YYINITDEPTH];
  YYSTYPE *rc_yyvs = rc_yyvsa;
  register YYSTYPE *rc_yyvsp;



#define YYPOPSTACK   (rc_yyvsp--, rc_yyssp--)

  YYSIZE_T rc_yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE rc_yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int rc_yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  rc_yystate = 0;
  rc_yyerrstatus = 0;
  rc_yynerrs = 0;
  rc_yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  rc_yyssp = rc_yyss;
  rc_yyvsp = rc_yyvs;


  goto rc_yysetstate;

/*------------------------------------------------------------.
| rc_yynewstate -- Push a new state, which is found in rc_yystate.  |
`------------------------------------------------------------*/
 rc_yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  rc_yyssp++;

 rc_yysetstate:
  *rc_yyssp = rc_yystate;

  if (rc_yyss + rc_yystacksize - 1 <= rc_yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T rc_yysize = rc_yyssp - rc_yyss + 1;

#ifdef rc_yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *rc_yyvs1 = rc_yyvs;
	short int *rc_yyss1 = rc_yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if rc_yyoverflow is a macro.  */
	rc_yyoverflow ("parser stack overflow",
		    &rc_yyss1, rc_yysize * sizeof (*rc_yyssp),
		    &rc_yyvs1, rc_yysize * sizeof (*rc_yyvsp),

		    &rc_yystacksize);

	rc_yyss = rc_yyss1;
	rc_yyvs = rc_yyvs1;
      }
#else /* no rc_yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto rc_yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= rc_yystacksize)
	goto rc_yyoverflowlab;
      rc_yystacksize *= 2;
      if (YYMAXDEPTH < rc_yystacksize)
	rc_yystacksize = YYMAXDEPTH;

      {
	short int *rc_yyss1 = rc_yyss;
	union rc_yyalloc *rc_yyptr =
	  (union rc_yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (rc_yystacksize));
	if (! rc_yyptr)
	  goto rc_yyoverflowlab;
	YYSTACK_RELOCATE (rc_yyss);
	YYSTACK_RELOCATE (rc_yyvs);

#  undef YYSTACK_RELOCATE
	if (rc_yyss1 != rc_yyssa)
	  YYSTACK_FREE (rc_yyss1);
      }
# endif
#endif /* no rc_yyoverflow */

      rc_yyssp = rc_yyss + rc_yysize - 1;
      rc_yyvsp = rc_yyvs + rc_yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) rc_yystacksize));

      if (rc_yyss + rc_yystacksize - 1 <= rc_yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", rc_yystate));

  goto rc_yybackup;

/*-----------.
| rc_yybackup.  |
`-----------*/
rc_yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* rc_yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  rc_yyn = rc_yypact[rc_yystate];
  if (rc_yyn == YYPACT_NINF)
    goto rc_yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (rc_yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      rc_yychar = YYLEX;
    }

  if (rc_yychar <= YYEOF)
    {
      rc_yychar = rc_yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      rc_yytoken = YYTRANSLATE (rc_yychar);
      YYDSYMPRINTF ("Next token is", rc_yytoken, &rc_yylval, &rc_yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  rc_yyn += rc_yytoken;
  if (rc_yyn < 0 || YYLAST < rc_yyn || rc_yycheck[rc_yyn] != rc_yytoken)
    goto rc_yydefault;
  rc_yyn = rc_yytable[rc_yyn];
  if (rc_yyn <= 0)
    {
      if (rc_yyn == 0 || rc_yyn == YYTABLE_NINF)
	goto rc_yyerrlab;
      rc_yyn = -rc_yyn;
      goto rc_yyreduce;
    }

  if (rc_yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", rc_yytname[rc_yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (rc_yychar != YYEOF)
    rc_yychar = YYEMPTY;

  *++rc_yyvsp = rc_yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (rc_yyerrstatus)
    rc_yyerrstatus--;

  rc_yystate = rc_yyn;
  goto rc_yynewstate;


/*-----------------------------------------------------------.
| rc_yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
rc_yydefault:
  rc_yyn = rc_yydefact[rc_yystate];
  if (rc_yyn == 0)
    goto rc_yyerrlab;
  goto rc_yyreduce;


/*-----------------------------.
| rc_yyreduce -- Do a reduction.  |
`-----------------------------*/
rc_yyreduce:
  /* rc_yyn is the number of a rule to reduce with.  */
  rc_yylen = rc_yyr2[rc_yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  rc_yyval = rc_yyvsp[1-rc_yylen];


  YY_REDUCE_PRINT (rc_yyn);
  switch (rc_yyn)
    {
        case 2:
#line 116 "rcfile.y"
    {
           }
    break;

  case 3:
#line 121 "rcfile.y"
    {
	     rc_yyval.section = rc_section = rc_yyvsp[0].section;
	   }
    break;

  case 4:
#line 125 "rcfile.y"
    {
	     if (rc_yyvsp[0].section)
	       {
		 if (rc_section == NULL)
		   {
		     rc_yyval.section = rc_section = rc_yyvsp[0].section;
		   }
		 else
		   {
		     rc_yyvsp[-1].section->next = rc_yyvsp[0].section;
		     rc_yyval.section = rc_yyvsp[0].section;
		   }
	       }
	   }
    break;

  case 5:
#line 140 "rcfile.y"
    {
	     lex_clear_state ();
	     rc_yychar = error_sync_begin ();
	     if (rc_yychar > 0)
	       {
		 rc_yyerrok;
		 rc_yyclearin;
	       }
	   }
    break;

  case 6:
#line 152 "rcfile.y"
    {
	     rc_yyval.section = NULL;
	   }
    break;

  case 7:
#line 156 "rcfile.y"
    {
	     rc_yyval.section = rc_section_create (rc_yyvsp[-2].begin_sec.name, rc_yyvsp[-2].begin_sec.line, rc_yyvsp[-1].stmtlist.head);
	   }
    break;

  case 8:
#line 160 "rcfile.y"
    {
	     rc_yyval.section = NULL;
	   }
    break;

  case 9:
#line 165 "rcfile.y"
    { verbatim (); }
    break;

  case 10:
#line 166 "rcfile.y"
    {
	     rc_yyval.begin_sec.line = cfg_line_num - 1;
	     rc_yyval.begin_sec.name = rc_yyvsp[-1].string;
	     if (rc_section_lookup (rc_section, rc_yyvsp[-1].string)) 
	       parse_error (_("Section %s already defined"), rc_yyvsp[-1].string);
	     rc_secdef = anubis_find_section (rc_yyvsp[-1].string);
	   }
    break;

  case 11:
#line 174 "rcfile.y"
    {
	     rc_yyval.begin_sec.line = cfg_line_num - 1;
	     rc_yyval.begin_sec.name = rc_yyvsp[-1].string;
	     if (rc_section_lookup (rc_section, rc_yyvsp[-1].string)) 
	       parse_error (_("Section %s already defined"), rc_yyvsp[-1].string);
	     rc_secdef = anubis_find_section (rc_yyvsp[-1].string);
	   }
    break;

  case 13:
#line 187 "rcfile.y"
    {
	     rc_yyval.stmtlist.head = rc_yyval.stmtlist.tail = rc_yyvsp[0].stmt;
	   }
    break;

  case 14:
#line 191 "rcfile.y"
    {
	     if (rc_yyvsp[0].stmt)
	       {
		 if (rc_yyval.stmtlist.head == NULL)
		   {
		     rc_yyval.stmtlist.head = rc_yyval.stmtlist.tail = rc_yyvsp[0].stmt;
		   }
		 else
		   {
		     rc_yyval.stmtlist.tail->next = rc_yyvsp[0].stmt;
		     rc_yyval.stmtlist.tail = rc_yyvsp[0].stmt;
		   } 
	       }
	   }
    break;

  case 15:
#line 208 "rcfile.y"
    {
	     rc_yyval.stmt = NULL;
	   }
    break;

  case 21:
#line 217 "rcfile.y"
    {
	     lex_clear_state ();
	     rc_yyerrok;
	     rc_yyclearin;
	     rc_yyval.stmt = NULL;
	   }
    break;

  case 22:
#line 226 "rcfile.y"
    {
	     int flags;
	     if (!check_kw (rc_yyvsp[-1].string, &flags))
	       {
		 parse_error (_("unknown keyword: %s"), rc_yyvsp[-1].string);
		 YYERROR;
	       }

	     rc_yyval.stmt = rc_stmt_create (rc_stmt_asgn);
	     rc_yyval.stmt->v.asgn.lhs = rc_yyvsp[-1].string;
	     if (list_count (rc_yyvsp[0].list))
	       {
		 char *s = list_item (rc_yyvsp[0].list, 0);
		 if (s && !strcmp (s, "="))
		   list_remove (rc_yyvsp[0].list, s, NULL);
	       }
	     rc_yyval.stmt->v.asgn.rhs = rc_yyvsp[0].list;
	     rc_yyval.stmt->v.asgn.flags = flags;
	   }
    break;

  case 23:
#line 248 "rcfile.y"
    {
	     verbatim ();
	   }
    break;

  case 24:
#line 254 "rcfile.y"
    {
	     rc_yyval.list = list_create ();
	     list_append (rc_yyval.list, rc_yyvsp[0].string);
	   }
    break;

  case 25:
#line 259 "rcfile.y"
    {
	     list_append (rc_yyvsp[-1].list, rc_yyvsp[0].string);
	     rc_yyval.list = rc_yyvsp[-1].list;
	   }
    break;

  case 27:
#line 269 "rcfile.y"
    {
	     rc_yyval.stmt = rc_stmt_create (rc_stmt_cond);
	     rc_yyval.stmt->v.cond.node = rc_yyvsp[-2].node;
	     rc_yyval.stmt->v.cond.iftrue = rc_yyvsp[-1].stmtlist.head;
	     rc_yyval.stmt->v.cond.iffalse = NULL;
	   }
    break;

  case 28:
#line 276 "rcfile.y"
    {
	     rc_yyval.stmt = rc_stmt_create (rc_stmt_cond);
	     rc_yyval.stmt->v.cond.node = rc_yyvsp[-4].node;
	     rc_yyval.stmt->v.cond.iftrue = rc_yyvsp[-3].stmtlist.head;
	     rc_yyval.stmt->v.cond.iffalse = rc_yyvsp[-1].stmtlist.head;
	   }
    break;

  case 30:
#line 286 "rcfile.y"
    {
	     rc_yyval.node = rc_yyvsp[-1].node;
	   }
    break;

  case 31:
#line 290 "rcfile.y"
    {
	     rc_yyval.node = rc_node_create (rc_node_bool);
	     rc_yyval.node->v.bool.op = bool_and;
	     rc_yyval.node->v.bool.left = rc_yyvsp[-2].node;
	     rc_yyval.node->v.bool.right = rc_yyvsp[0].node;
	   }
    break;

  case 32:
#line 297 "rcfile.y"
    {
	     rc_yyval.node = rc_node_create (rc_node_bool);
	     rc_yyval.node->v.bool.op = bool_or;
	     rc_yyval.node->v.bool.left = rc_yyvsp[-2].node;
	     rc_yyval.node->v.bool.right = rc_yyvsp[0].node;
	   }
    break;

  case 33:
#line 304 "rcfile.y"
    {
	     rc_yyval.node = rc_node_create (rc_node_bool);
	     rc_yyval.node->v.bool.op = bool_not;
	     rc_yyval.node->v.bool.left = rc_yyvsp[0].node;
	     rc_yyval.node->v.bool.right = NULL;
	   }
    break;

  case 36:
#line 317 "rcfile.y"
    {
	     rc_yyval.msgpart.part = HEADER;
	     rc_yyval.msgpart.key = rc_yyvsp[0].regex;
	     rc_yyval.msgpart.string = NULL;
	   }
    break;

  case 37:
#line 323 "rcfile.y"
    {
	     rc_yyval.msgpart.part = HEADER;
	     rc_yyval.msgpart.key = NULL;
	     rc_yyval.msgpart.string = rc_yyvsp[-1].string;
	   }
    break;

  case 38:
#line 331 "rcfile.y"
    {
	     rc_yyval.msgpart.string = NULL;
	     rc_yyval.msgpart.key = NULL;
           }
    break;

  case 40:
#line 339 "rcfile.y"
    {
	     rc_yyval.msgpart = rc_yyvsp[0].msgpart;
	     rc_yyval.msgpart.part = rc_yyvsp[-1].num;
	   }
    break;

  case 42:
#line 347 "rcfile.y"
    {
	     rc_yyval.msgpart = rc_yyvsp[0].msgpart;
	     if (rc_yyval.msgpart.key)
	       parse_error ("regexp is not allowed in this context");
	   }
    break;

  case 43:
#line 355 "rcfile.y"
    {
	     rc_yyval.msgpart = rc_yyvsp[0].msgpart;
	     if (!rc_yyval.msgpart.key)
	       {
		 rc_yyval.msgpart.key = anubis_regex_compile (rc_yyval.msgpart.string, R_EXACT);
		 xfree (rc_yyval.msgpart.string);
	       }
	   }
    break;

  case 44:
#line 366 "rcfile.y"
    {
	     rc_yyval.regex = anubis_regex_compile (rc_yyvsp[-1].string, rc_yyvsp[-3].num);
	     free (rc_yyvsp[-1].string);
	   }
    break;

  case 45:
#line 373 "rcfile.y"
    {
	     rc_yyval.string = NULL;
	   }
    break;

  case 46:
#line 377 "rcfile.y"
    {
	     rc_yyval.string = rc_yyvsp[-1].string;
	   }
    break;

  case 47:
#line 383 "rcfile.y"
    {
	     rc_yyval.node = rc_node_create (rc_node_expr);
	     rc_yyval.node->v.expr.part = rc_yyvsp[-4].msgpart.part;
	     rc_yyval.node->v.expr.key = rc_yyvsp[-4].msgpart.string;
	     rc_yyval.node->v.expr.re = anubis_regex_compile (rc_yyvsp[0].string, rc_yyvsp[-1].num|rc_yyvsp[-3].num);
	     free (rc_yyvsp[0].string);
	   }
    break;

  case 48:
#line 393 "rcfile.y"
    {
	     rc_yyval.num = def_regex_modifier;
	     reg_modifier_add (&rc_yyval.num, rc_yyvsp[0].string);
	     xfree (rc_yyvsp[0].string);
	   }
    break;

  case 49:
#line 399 "rcfile.y"
    {
	     reg_modifier_add (&rc_yyvsp[-1].num, rc_yyvsp[0].string);
	     xfree (rc_yyvsp[0].string);
	     rc_yyval.num = rc_yyvsp[-1].num;
	   }
    break;

  case 50:
#line 407 "rcfile.y"
    {
	     rc_yyval.num = def_regex_modifier;
	   }
    break;

  case 52:
#line 414 "rcfile.y"
    {
	     rc_yyval.string = rc_yyvsp[0].string;
	   }
    break;

  case 53:
#line 420 "rcfile.y"
    {
	     if (!is_prog_allowed ())
	       YYERROR;
	   }
    break;

  case 56:
#line 433 "rcfile.y"
    {
	     rc_yyval.stmt = rc_stmt_create (rc_stmt_rule);
	     rc_yyval.stmt->v.rule.node = rc_yyvsp[-3].node;
	     rc_yyval.stmt->v.rule.stmt = rc_yyvsp[-1].stmtlist.head;
	   }
    break;

  case 57:
#line 441 "rcfile.y"
    {
	     rc_yyval.node = rc_node_create (rc_node_expr);
	     rc_yyval.node->v.expr.part = HEADER;
	     rc_yyval.node->v.expr.key = strdup (X_ANUBIS_RULE_HEADER);
	     rc_yyval.node->v.expr.re = anubis_regex_compile (rc_yyvsp[0].string, rc_yyvsp[-1].num);
	     free (rc_yyvsp[0].string);
	   }
    break;

  case 58:
#line 451 "rcfile.y"
    {
	     if (!is_prog_allowed ())
	       YYERROR;
	   }
    break;

  case 61:
#line 462 "rcfile.y"
    {
	     if (!is_prog_allowed ())
	       YYERROR;

	     rc_yyval.stmt = rc_stmt_create (rc_stmt_inst);
	     rc_yyval.stmt->v.inst.opcode = inst_stop;
	     rc_yyval.stmt->v.inst.part = NIL;
	     rc_yyval.stmt->v.inst.key  = NULL;
	     rc_yyval.stmt->v.inst.key2 = NULL;
	     rc_yyval.stmt->v.inst.arg  = NULL;
	   }
    break;

  case 62:
#line 474 "rcfile.y"
    {
	     if (!is_prog_allowed ())
	       YYERROR;

	     rc_yyval.stmt = rc_stmt_create (rc_stmt_inst);
	     rc_yyval.stmt->v.inst.opcode = inst_call;
	     rc_yyval.stmt->v.inst.key = NULL;
	     rc_yyval.stmt->v.inst.part = NIL;
	     rc_yyval.stmt->v.inst.key2 = NULL;
	     rc_yyval.stmt->v.inst.arg  = rc_yyvsp[0].string;
	   }
    break;

  case 63:
#line 486 "rcfile.y"
    {
	     if (!is_prog_allowed ())
	       YYERROR;

	     rc_yyval.stmt = rc_stmt_create (rc_stmt_inst);
	     rc_yyval.stmt->v.inst.opcode = inst_add;
	     rc_yyval.stmt->v.inst.part = rc_yyvsp[-1].msgpart.part;
	     rc_yyval.stmt->v.inst.key  = NULL;
	     rc_yyval.stmt->v.inst.key2 = rc_yyvsp[-1].msgpart.string;
	     rc_yyval.stmt->v.inst.arg  = rc_yyvsp[0].string;
	   }
    break;

  case 64:
#line 498 "rcfile.y"
    {
	     if (!is_prog_allowed ())
	       YYERROR;

	     rc_yyval.stmt = rc_stmt_create (rc_stmt_inst);
	     rc_yyval.stmt->v.inst.opcode = inst_remove;
	     rc_yyval.stmt->v.inst.part = rc_yyvsp[0].msgpart.part;
	     rc_yyval.stmt->v.inst.key = rc_yyvsp[0].msgpart.key;
	     rc_yyval.stmt->v.inst.key2 = NULL;
	     rc_yyval.stmt->v.inst.arg  = NULL;
	   }
    break;

  case 65:
#line 510 "rcfile.y"
    {
	     if (!is_prog_allowed ())
	       YYERROR;

	     rc_yyval.stmt = rc_stmt_create (rc_stmt_inst);
	     rc_yyval.stmt->v.inst.opcode = inst_modify;
	     rc_yyval.stmt->v.inst.part = rc_yyvsp[-2].msgpart.part;
	     rc_yyval.stmt->v.inst.key  = rc_yyvsp[-2].msgpart.key;
	     rc_yyval.stmt->v.inst.key2 = rc_yyvsp[-1].string;
	     rc_yyval.stmt->v.inst.arg  = rc_yyvsp[0].string;
	   }
    break;

  case 66:
#line 522 "rcfile.y"
    {
	     if (!is_prog_allowed ())
	       YYERROR;

	     rc_yyval.stmt = rc_stmt_create (rc_stmt_inst);
	     rc_yyval.stmt->v.inst.opcode = inst_modify;
	     rc_yyval.stmt->v.inst.part = rc_yyvsp[-1].msgpart.part;
	     rc_yyval.stmt->v.inst.key  = rc_yyvsp[-1].msgpart.key;
	     if (rc_yyvsp[0].string == NULL)
	       {
		 parse_error (_("missing replacement value"));
	       }
	     rc_yyval.stmt->v.inst.key2 = rc_yyvsp[0].string;
	     rc_yyval.stmt->v.inst.arg  = NULL;
	   }
    break;

  case 67:
#line 540 "rcfile.y"
    {
	     if (!is_prog_allowed ())
	       YYERROR;

	     def_regex_modifier = rc_yyvsp[0].num;
	     rc_yyval.stmt = NULL;
	   }
    break;


    }

/* Line 1010 of yacc.c.  */
#line 1719 "y.tab.c"

  rc_yyvsp -= rc_yylen;
  rc_yyssp -= rc_yylen;


  YY_STACK_PRINT (rc_yyss, rc_yyssp);

  *++rc_yyvsp = rc_yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  rc_yyn = rc_yyr1[rc_yyn];

  rc_yystate = rc_yypgoto[rc_yyn - YYNTOKENS] + *rc_yyssp;
  if (0 <= rc_yystate && rc_yystate <= YYLAST && rc_yycheck[rc_yystate] == *rc_yyssp)
    rc_yystate = rc_yytable[rc_yystate];
  else
    rc_yystate = rc_yydefgoto[rc_yyn - YYNTOKENS];

  goto rc_yynewstate;


/*------------------------------------.
| rc_yyerrlab -- here on detecting error |
`------------------------------------*/
rc_yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!rc_yyerrstatus)
    {
      ++rc_yynerrs;
#if YYERROR_VERBOSE
      rc_yyn = rc_yypact[rc_yystate];

      if (YYPACT_NINF < rc_yyn && rc_yyn < YYLAST)
	{
	  YYSIZE_T rc_yysize = 0;
	  int rc_yytype = YYTRANSLATE (rc_yychar);
	  const char* rc_yyprefix;
	  char *rc_yymsg;
	  int rc_yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int rc_yyxbegin = rc_yyn < 0 ? -rc_yyn : 0;

	  /* Stay within bounds of both rc_yycheck and rc_yytname.  */
	  int rc_yychecklim = YYLAST - rc_yyn;
	  int rc_yyxend = rc_yychecklim < YYNTOKENS ? rc_yychecklim : YYNTOKENS;
	  int rc_yycount = 0;

	  rc_yyprefix = ", expecting ";
	  for (rc_yyx = rc_yyxbegin; rc_yyx < rc_yyxend; ++rc_yyx)
	    if (rc_yycheck[rc_yyx + rc_yyn] == rc_yyx && rc_yyx != YYTERROR)
	      {
		rc_yysize += rc_yystrlen (rc_yyprefix) + rc_yystrlen (rc_yytname [rc_yyx]);
		rc_yycount += 1;
		if (rc_yycount == 5)
		  {
		    rc_yysize = 0;
		    break;
		  }
	      }
	  rc_yysize += (sizeof ("syntax error, unexpected ")
		     + rc_yystrlen (rc_yytname[rc_yytype]));
	  rc_yymsg = (char *) YYSTACK_ALLOC (rc_yysize);
	  if (rc_yymsg != 0)
	    {
	      char *rc_yyp = rc_yystpcpy (rc_yymsg, "syntax error, unexpected ");
	      rc_yyp = rc_yystpcpy (rc_yyp, rc_yytname[rc_yytype]);

	      if (rc_yycount < 5)
		{
		  rc_yyprefix = ", expecting ";
		  for (rc_yyx = rc_yyxbegin; rc_yyx < rc_yyxend; ++rc_yyx)
		    if (rc_yycheck[rc_yyx + rc_yyn] == rc_yyx && rc_yyx != YYTERROR)
		      {
			rc_yyp = rc_yystpcpy (rc_yyp, rc_yyprefix);
			rc_yyp = rc_yystpcpy (rc_yyp, rc_yytname[rc_yyx]);
			rc_yyprefix = " or ";
		      }
		}
	      rc_yyerror (rc_yymsg);
	      YYSTACK_FREE (rc_yymsg);
	    }
	  else
	    rc_yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	rc_yyerror ("syntax error");
    }



  if (rc_yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (rc_yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (rc_yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (rc_yyssp == rc_yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", rc_yystos[*rc_yyssp], rc_yyvsp, rc_yylsp);
		 rc_yydestruct (rc_yystos[*rc_yyssp], rc_yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", rc_yytoken, &rc_yylval, &rc_yylloc);
	  rc_yydestruct (rc_yytoken, &rc_yylval);
	  rc_yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto rc_yyerrlab1;


/*---------------------------------------------------.
| rc_yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
rc_yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     rc_yyerrorlab therefore never appears in user code.  */
  if (0)
     goto rc_yyerrorlab;
#endif

  rc_yyvsp -= rc_yylen;
  rc_yyssp -= rc_yylen;
  rc_yystate = *rc_yyssp;
  goto rc_yyerrlab1;


/*-------------------------------------------------------------.
| rc_yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
rc_yyerrlab1:
  rc_yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      rc_yyn = rc_yypact[rc_yystate];
      if (rc_yyn != YYPACT_NINF)
	{
	  rc_yyn += YYTERROR;
	  if (0 <= rc_yyn && rc_yyn <= YYLAST && rc_yycheck[rc_yyn] == YYTERROR)
	    {
	      rc_yyn = rc_yytable[rc_yyn];
	      if (0 < rc_yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (rc_yyssp == rc_yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", rc_yystos[*rc_yyssp], rc_yyvsp, rc_yylsp);
      rc_yydestruct (rc_yystos[rc_yystate], rc_yyvsp);
      YYPOPSTACK;
      rc_yystate = *rc_yyssp;
      YY_STACK_PRINT (rc_yyss, rc_yyssp);
    }

  if (rc_yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++rc_yyvsp = rc_yylval;


  rc_yystate = rc_yyn;
  goto rc_yynewstate;


/*-------------------------------------.
| rc_yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
rc_yyacceptlab:
  rc_yyresult = 0;
  goto rc_yyreturn;

/*-----------------------------------.
| rc_yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
rc_yyabortlab:
  rc_yyresult = 1;
  goto rc_yyreturn;

#ifndef rc_yyoverflow
/*----------------------------------------------.
| rc_yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
rc_yyoverflowlab:
  rc_yyerror ("parser stack overflow");
  rc_yyresult = 2;
  /* Fall through.  */
#endif

rc_yyreturn:
#ifndef rc_yyoverflow
  if (rc_yyss != rc_yyssa)
    YYSTACK_FREE (rc_yyss);
#endif
  return rc_yyresult;
}


#line 549 "rcfile.y"


static int
err_line_num (void)
{
  return rc_yychar == EOL ? cfg_line_num - 1 : cfg_line_num;
}

static void
default_error_printer (void *data, 
		       const char *filename, int line,
		       const char *fmt, va_list ap)
{
  char buf[LINEBUFFER];
  vsnprintf (buf, sizeof buf, fmt, ap);
  anubis_error (0, 0, "%s:%d: %s", filename, line, buf);
}	

static void *rc_error_printer_data;
static RC_ERROR_PRINTER rc_error_printer = default_error_printer;

void
parse_error (const char *fmt, ...)
{
  va_list ap;
  
  va_start (ap, fmt);
  rc_error_printer (rc_error_printer_data,
		    cfg_file, err_line_num (), fmt, ap);
  va_end (ap);
  error_count++;
}

int
rc_yyerror (char *s)
{
  parse_error ("%s", s);
  return 0;
}

RC_SECTION *
rc_parse (char *name)
{
  int status;
  if (rc_open (name))
    return NULL;

  rc_section = NULL;
  error_count = 0;
  status = rc_yyparse ();
  if (status || error_count) 
    rc_section_list_destroy (&rc_section);
  if (debug_level)
    rc_section_print (rc_section);
  return rc_section;
}

/* Same as rc_parse() but also allows user to specify his own
   error printer function */
RC_SECTION *
rc_parse_ep (char *name, RC_ERROR_PRINTER errprn, void *data)
{
  void *save_ep_data = rc_error_printer_data;
  void *save_ep_handler = rc_error_printer;
  RC_SECTION *sec;
  rc_error_printer = errprn;
  rc_error_printer_data = data;
  sec = rc_parse (name);
  rc_error_printer = save_ep_handler;
  rc_error_printer_data = save_ep_data;
  return sec;
}

void
rc_set_debug_level (char *arg)
{
  if (!arg)
    debug_level = 0;
  else if (arg[1] != 0 || !isdigit (arg[0]))
    {
      mprintf (_("Not a valid debugging level: %s"), arg);
      return;
    }
  else
    debug_level = arg[0] - '0';
  if (debug_level > 1)
    rc_yydebug = debug_level;
}


/* Locations */

/* To save space, each filename is allocated only once. Each filename
   has a reference count associated with it. It is incremented
   with each new allocation of the same string. It is decremented
   with each attempt to free the string. Only when the reference count
   drops to zero is the storage actually reclaimed */

struct strobj {
  char *value;          /* String value */
  size_t refcnt;        /* Reference count */
};

/* A list of string objects */
static ANUBIS_LIST /* of struct strobj */ *string_list;

static int
string_comparator (void *item, void *data)
{
  struct strobj *s = item;
  return strcmp (s->value, (char*) data);
}

static int
value_comparator (void *item, void *data)
{
  struct strobj *s = item;
  return s->value != data;
}

/* Looks up a string object with the given value. If not found, a
   new object is created and added to the list. In any case the
   reference count of the objet is incremented.
   The return value is the string value associated with the object. */
char *
string_create (char *str)
{
  struct strobj *s = list_locate (string_list, str, string_comparator);
  if (!s)
    {
      s = xmalloc (sizeof (*s));
      s->value = strdup (str);
      s->refcnt = 0;
      list_prepend (string_list, s);
    }
  s->refcnt++;
  return s->value;
}

/* Destroys the object with the given string value */
void
string_destroy (char *str)
{
  struct strobj *s = list_locate (string_list, str, value_comparator);
  if (s)
    {
      if (--s->refcnt == 0)
	{
	  free (s->value);
	  list_remove (string_list, str, value_comparator);
	}
    }
}

/* Initializes LOC with the current location. If the second argument
   is not zero, it overrides the current line number. */
void
rc_mark_loc (RC_LOC *loc, size_t line)
{
  loc->file = string_create (cfg_file);
  loc->line = line ? line : cfg_line_num;
}

/* Reclaims the memory associated with the LOC */
void
rc_destroy_loc (RC_LOC *loc)
{
  string_destroy (loc->file);
}


/* Section manipulation */

RC_SECTION *
rc_section_create (char *name, size_t line, RC_STMT *stmt)
{
  RC_SECTION *p = xmalloc (sizeof (*p));
  rc_mark_loc (&p->loc, line);
  p->next = NULL;
  p->name = name;
  p->stmt = stmt;
  return p;
}

void
rc_section_destroy (RC_SECTION **s)
{
  rc_stmt_list_destroy ((*s)->stmt);
  rc_destroy_loc (&(*s)->loc);
  xfree ((*s)->name);
  xfree (*s);
}

void
rc_section_list_destroy (RC_SECTION **s)
{
  while (*s)
    {
      RC_SECTION *next = (*s)->next;
      rc_section_destroy (s);
      *s = next;
    }
}

void
rc_section_print (RC_SECTION *sect)
{
  for (; sect; sect = sect->next)
    {
      printf ("BEGIN SECTION %s\n", sect->name);
      rc_stmt_print (sect->stmt, 1);
      printf ("END SECTION %s\n", sect->name);
    }
}

RC_SECTION *
rc_section_lookup (RC_SECTION *sec, char *name)
{
  for (; sec; sec = sec->next)
    if (strcmp (sec->name, name) == 0)
      break;
  return sec;
}

void
rc_section_link (RC_SECTION **ap, RC_SECTION *b)
{
  RC_SECTION *a, *prev;

  /* Remove all sections with prio == override (the default) */
  a = *ap;
  prev = NULL;
  while (a)
    {
      RC_SECTION *next = a->next;
      struct rc_secdef *sd = anubis_find_section (a->name);
      if (sd && sd->prio == prio_user_only)
	{
	  if (prev)
	    prev->next = next;
	  else
	    *ap = next;
	  rc_section_destroy (&a);
	} else
	  prev = a;
      a = next;
    }
		
  if (!*ap)
    {
      *ap = b;
      return;
    }

  for (a = *ap; a->next; a = a->next)
    ;

  while (b)
    {
      struct rc_secdef *sd;
      RC_SECTION *nxtptr = b->next;

      sd = anubis_find_section (b->name);
      if (sd)
	{
	  switch (sd->prio) {
	  case prio_user:
	    b->next = *ap;
	    *ap = b;
	    break;
	    
	  case prio_system_only:
	    rc_section_destroy (&b);
	    break;
	    
	  default:
	    b->next = NULL;
	    a->next = b;
	    a = b;
	  }
	}
      else
	{
	  b->next = NULL;
	  a->next = b;
	  a = b;
	}
      b = nxtptr;
    }
}

/* Assignment manipulations */

void
rc_asgn_destroy (RC_ASGN *asgn)
{
  xfree (asgn->lhs);
  list_destroy (&asgn->rhs, anubis_free_list_item, NULL);
}

/* Bools */

void
rc_bool_destroy (RC_BOOL *bool)
{
  rc_node_destroy (bool->left);
  rc_node_destroy (bool->right);
}

/* Nodes */

RC_NODE *
rc_node_create (enum rc_node_type t)
{
  RC_NODE *p = xmalloc (sizeof (*p));
  memset (p, 0, sizeof (*p));
  rc_mark_loc (&p->loc, 0);
  p->type = t;
  return p;
}

void
rc_node_destroy (RC_NODE *node)
{
  if (!node)
    return;
  switch (node->type) {
  case rc_node_bool:
    rc_bool_destroy (&node->v.bool);
    break;
    
  case rc_node_expr:
    free (node->v.expr.key);
    anubis_regex_free (&node->v.expr.re);
  }
  rc_destroy_loc (&node->loc);
  xfree (node);
}

static char *
part_string (int part)
{
  switch (part) {
  case NIL:
    return "NIL";
  case COMMAND:
    return "COMMAND";
  case HEADER:
    return "HEADER";
  case BODY:
    return "BODY";
  default:
    return "UNKNOWN";
  }
}

void
rc_node_print (RC_NODE *node)
{
  switch (node->type) {
  case rc_node_expr:
    printf ("%s", part_string (node->v.expr.part));
    if (node->v.expr.key && node->v.expr.key[0] != '\n')
      printf ("[%s]",node->v.expr.key);
    printf (" ");
    anubis_regex_print (node->v.expr.re);
    break;
		
  case rc_node_bool:
    switch (node->v.bool.op) {
    case bool_not:
      printf ("NOT (");
      rc_node_print (node->v.bool.left);
      printf (")");
      break;
      
    case bool_and:
      printf ("AND (");
      rc_node_print (node->v.bool.left);
      printf (",");
      rc_node_print (node->v.bool.right);
      printf (")");
      break;
      
    case bool_or:
      printf ("OR (");
      rc_node_print (node->v.bool.left);
      printf (",");
      rc_node_print (node->v.bool.right);
      printf (")");
      break;
    }
  }
}

/* Rules */

void
rc_rule_destroy (RC_RULE *rule)
{
  rc_node_destroy (rule->node);
  rc_stmt_list_destroy (rule->stmt);
}

/* Conditionals */

void
rc_cond_destroy (RC_COND *cond)
{
  rc_node_destroy (cond->node);
  rc_stmt_list_destroy (cond->iftrue);
  rc_stmt_list_destroy (cond->iffalse);
}

/* Instructions */

void
rc_inst_destroy (RC_INST *inst)
{
  anubis_regex_free (&inst->key);
  free (inst->key2);
  free (inst->arg);
}

static char *
inst_name (enum rc_inst_opcode opcode)
{
  switch (opcode) {
  case inst_stop:
    return "STOP";
  case inst_call:
    return "CALL";
  case inst_add:
    return "ADD";
  case inst_remove:
    return "REMOVE";
  case inst_modify:
    return "MODIFY";
  }
  return "UNKNOWN";
}

void
rc_inst_print (RC_INST *inst, int level)
{
  rc_level_print (level, inst_name (inst->opcode));
  switch (inst->opcode) {
  case inst_stop:
    break;
    
  case inst_call:
    printf (" %s", inst->arg);
    break;
    
  case inst_add:
    printf (" %s[%s]", part_string (inst->part), inst->key2);
    if (inst->arg)
      printf (" \"%s\"", inst->arg);
    break;
    
  default:
    printf (" %s ", part_string (inst->part));
    if (inst->key)
      anubis_regex_print (inst->key);
    if (inst->key2)
      printf (" [%s]", inst->key2);
    if (inst->arg)
      printf (" \"%s\"", inst->arg);
  }
}

/* Statements */

RC_STMT *
rc_stmt_create (enum rc_stmt_type type)
{
  RC_STMT *p = xmalloc (sizeof (*p));
  memset (p, 0, sizeof (*p));
  rc_mark_loc (&p->loc, 0);
  p->type = type;
  return p;
}

void
rc_stmt_destroy (RC_STMT *stmt)
{
  switch (stmt->type) {
  case rc_stmt_asgn:
    rc_asgn_destroy (&stmt->v.asgn);
    break;
    
  case rc_stmt_rule:
    rc_rule_destroy (&stmt->v.rule);
    break;
    
  case rc_stmt_cond:
    rc_cond_destroy (&stmt->v.cond);
    break;
    
  case rc_stmt_inst:
    rc_inst_destroy (&stmt->v.inst);
  }
  rc_destroy_loc (&stmt->loc);
  xfree (stmt);
}

void
rc_stmt_list_destroy (RC_STMT *stmt)
{
  while (stmt)
    {
      RC_STMT *next = stmt->next;
      rc_stmt_destroy (stmt);
      stmt = next;
    }
}

void
rc_level_print (int level, char *str)
{
  int i;
  
  for (i = 0; i < level*2; i++)
    putchar (' ');
  printf ("%s", str);
}

static int
_print_str (void *item, void *data)
{
  printf (" %s", (char*)item);
  return 0;
}

static int
_print_stars (void *item, void *data)
{
  printf (" ***");
  return 0;
}

void
rc_stmt_print (RC_STMT *stmt, int level)
{
  for (; stmt; stmt = stmt->next)
    {
      switch (stmt->type) {
      case rc_stmt_asgn:
	rc_level_print (level, "ASGN: ");
	printf ("%s =", stmt->v.asgn.lhs);
	list_iterate (stmt->v.asgn.rhs,
		      (stmt->v.asgn.flags & KWF_HIDDEN) ?
		      _print_stars : _print_str, NULL);
	break;
	
      case rc_stmt_cond:
	rc_level_print (level, "COND: ");
	rc_node_print (stmt->v.cond.node);
	printf ("\n");
	rc_level_print (level, "IFTRUE:\n");
	rc_stmt_print (stmt->v.cond.iftrue, level+1);
	if (stmt->v.cond.iffalse)
	  {
	    rc_level_print (level, "IFFALSE:\n");
	    rc_stmt_print (stmt->v.cond.iffalse, level+1);
	  }
	rc_level_print (level, "END COND");
	break;
	
      case rc_stmt_rule:
	rc_level_print (level, "RULE: ");
	rc_node_print (stmt->v.rule.node);
	printf ("\n");
	rc_level_print (level, "BODY\n");
	rc_stmt_print (stmt->v.rule.stmt, level+1);
	rc_level_print (level, "END RULE");
	break;
	
      case rc_stmt_inst:
	rc_inst_print (&stmt->v.inst, level);
	break;
	
      default:
	abort ();
      }
      printf ("\n");
    }
}

int
reg_modifier_add (int *flag, char *opt)
{
  /* Regex types: */
  if (!strcasecmp (opt, "re") || !strcasecmp (opt, "regex"))
    {
      re_set_type (*flag, re_typeof (def_regex_modifier));
    }
  else if (!strcasecmp (opt, "posix"))
    {
      re_set_type (*flag, R_POSIX);
    }
#ifdef HAVE_PCRE
  else if (!strcasecmp (opt, "perlre")
	   || !strcasecmp (opt, "perl"))
    {
      re_set_type (*flag, R_PERLRE);
    }
#endif /* HAVE_PCRE */
  else if (!strcasecmp (opt, "ex") || !strcasecmp (opt, "exact"))
    {
      re_set_type (*flag, R_EXACT);
    }

  /* Modifiers: */
  else if (!strcasecmp (opt, "basic"))
    {
      re_set_type (*flag, R_POSIX);
      re_set_flag (*flag, R_BASIC);
    }
  else if (!strcasecmp (opt, "extended"))
    {
      re_set_type (*flag, R_POSIX);
      re_clear_flag (*flag, R_BASIC);
    }
  else if (!strcasecmp (opt, "scase"))
    re_set_flag (*flag, R_SCASE);
  else if (!strcasecmp (opt, "icase"))
    re_clear_flag (*flag, R_SCASE);
  else
    {
      parse_error (_("Unknown regexp modifier"));
      return 1;
    }
  return 0;
}


/* ******************************* Runtime ********************************* */

static struct rc_secdef_child *
child_copy (struct rc_secdef_child *p)
{
  struct rc_secdef_child *newp = xmalloc (sizeof (*newp));
  memcpy (newp, p, sizeof (*newp));
  newp->next = NULL;
  return newp;
}	

void
rc_secdef_add_child (struct rc_secdef *def,
		     struct rc_secdef_child *child)
{
  struct rc_secdef_child *p = child_copy (child);
  if (!def->child)
    def->child = p;
  else
    {
      struct rc_secdef_child *last;
      for (last = def->child; last->next; last = last->next)
	;
      last->next = p;
    }
}

struct rc_secdef_child *
rc_child_lookup (struct rc_secdef_child *child, char *str,
		 int method, int *key, int *flags)
{
  for (; child; child = child->next)
    {
      if (child->method & method)
	{
	  struct rc_kwdef *kw;
	  for (kw = child->kwdef; kw->name; kw++)
	    if (!strcmp (kw->name, str))
	      {
		*key = kw->tok;
		if (flags)
		  *flags = kw->flags;
		return child;
	      }
	}
    }
  return NULL;
}

struct eval_env
{
  int method;
  int cmp_method;
  struct rc_secdef_child *child;
  MESSAGE *msg;
  void *data;
  int refcnt;
  char **refstr;
  jmp_buf jmp;
  RC_LOC loc;
  int traceable;
};

static void asgn_eval (struct eval_env *env, RC_ASGN *asgn);
static int node_eval (struct eval_env *env, RC_NODE *node);
static int bool_eval (struct eval_env *env, RC_BOOL *bool);
static void cond_eval (struct eval_env *env, RC_COND *cond);
static void rule_eval (struct eval_env *env, RC_RULE *rule);
static void stmt_list_eval (struct eval_env *env, RC_STMT *stmt);
static void inst_eval (struct eval_env *env, RC_INST *inst);

#define VALID_STR(s) ((s)?(s):"NULL")

void
inst_eval (struct eval_env *env, RC_INST *inst)
{
  char *arg = NULL, *argp = NULL;
  
  if (!env->msg)
    return; /* FIXME: bail out? */
	
  if (inst->arg)
    {
      if (env->refstr)
	arg = argp = substitute (inst->arg, env->refstr);
      else
	arg = inst->arg;
    }
  
  switch (inst->opcode) {
  case inst_stop:
    tracefile (&env->loc, _("STOP"));
    longjmp (env->jmp, 1);
    break;
    
  case inst_call:
    tracefile (&env->loc, _("Calling %s"), inst->arg);
    rcfile_call_section (env->method, inst->arg,
			 env->data, env->msg);
    break;
    
  case inst_add:
    tracefile (&env->loc, _("ADD %s [%s] %s"),
	       (inst->part == BODY) ? "BODY" : "HEADER",
	       VALID_STR (inst->key2), arg);
    if (inst->part == BODY) 
      message_add_body (env->msg, inst->key2, arg);
    else
      message_add_header (env->msg, inst->key2, arg);
    break;
    
  case inst_modify:
    tracefile (&env->loc, _("MODIFY %s [%s] [%s] %s"),
	       (inst->part == BODY) ? "BODY" : "HEADER",
	       anubis_regex_source (inst->key), 
	       VALID_STR (inst->key2), arg);
    
    if (inst->part == BODY)
      message_modify_body (env->msg, inst->key, arg);
    else
      message_modify_headers (env->msg, inst->key,
			      inst->key2, arg);
    break;
    
  case inst_remove:
    tracefile (&env->loc, _("REMOVE HEADER [%s]"),
	       anubis_regex_source (inst->key));
    message_remove_headers (env->msg, inst->key);
    break;
    
  default:
    abort ();
  }
  
  if (argp)
    free (argp);
}
	
void
asgn_eval (struct eval_env *env, RC_ASGN *asgn)
{
  int key;
  struct rc_secdef_child *p = rc_child_lookup (env->child, asgn->lhs,
					       env->method, &key, NULL);
  if (!p)
    return;
  
  if (env->traceable)
    tracefile (&env->loc, _("Executing %s"), asgn->lhs);

  if (env->refstr)
    {
      char *s;
      ANUBIS_LIST *arg = list_create ();
      ITERATOR *itr = iterator_create (asgn->rhs);
      for (s = iterator_first (itr); s; s = iterator_next (itr))
	{
	  char *str = substitute (s, env->refstr);
	  list_append (arg, str);
	}
      iterator_destroy (&itr);
      p->parser (env->method, key, arg, p->data, env->data, env->msg);
      list_destroy (&arg, anubis_free_list_item, NULL);
    }
  else
    p->parser (env->method, key, asgn->rhs, p->data, env->data,
	       env->msg);
}


int
re_eval_list (struct eval_env *env, char *key,
	      RC_REGEX *re, ANUBIS_LIST *list)
{
  ASSOC *p;
  ITERATOR *itr;
  int rc = 0;

  itr = iterator_create (list);
  for (p = iterator_first (itr); rc == 0 && p; p = iterator_next (itr))
    {
      if (!p->key || !strcasecmp (p->key, key))
	rc = anubis_regex_match (re, p->value,
				 &env->refcnt, &env->refstr);
    }
  iterator_destroy (&itr);
  return rc;
}

int
re_eval_text (struct eval_env *env, RC_REGEX *re, char *text)
{
  /* FIXME */
  return anubis_regex_match (re, text, &env->refcnt, &env->refstr);
}

int
expr_eval (struct eval_env *env, RC_EXPR *expr)
{
  int rc;

  if (env->refstr && anubis_regex_refcnt (expr->re))
    {
      xfree_pptr (env->refstr);
      env->refcnt = 0;
    }
  
  switch (expr->part) {
  case COMMAND:
    rc = re_eval_list (env, expr->key, expr->re,
		       env->msg->commands);
    break;
    
  case HEADER:
    rc = re_eval_list (env, expr->key, expr->re, env->msg->header);
    break;
    
  case BODY:
    rc = re_eval_text (env, expr->re, env->msg->body);
    break;
    
  default:
    abort ();
  }

  if (rc)
    {
      if (!strcmp (VALID_STR (expr->key), X_ANUBIS_RULE_HEADER))
	tracefile (&env->loc, _("Matched trigger \"%s\""),
		   anubis_regex_source (expr->re));
      else
	tracefile (&env->loc, 
		   _("Matched condition %s[%s] \"%s\""),
		   part_string (expr->part),
		   VALID_STR (expr->key),
		   anubis_regex_source (expr->re));
    }
  return rc;
}

int
node_eval (struct eval_env *env, RC_NODE *node)
{
  int rc; /* It won't be used uninitialized despite what cc says.
	     Note default: branch below */
  
  env->loc = node->loc;
  switch (node->type) {
  case rc_node_bool:
    rc = bool_eval (env, &node->v.bool);
    break;
    
  case rc_node_expr:
    rc = expr_eval (env, &node->v.expr);
    break;
    
  default:
    abort ();
  }
  
  return rc;
}

int
bool_eval (struct eval_env *env, RC_BOOL *bool)
{
  int rc = node_eval (env, bool->left);

  switch (bool->op) {
  case bool_not:
    return !rc;
    
  case bool_and:
    if (!rc)
      return 0;
    break;
    
  case bool_or:
    if (rc)
      return 1;
    break;
  }
  return node_eval (env, bool->right);
}

void
cond_eval (struct eval_env *env, RC_COND *cond)
{
  if (node_eval (env, cond->node))
    stmt_list_eval (env, cond->iftrue);
  else
    stmt_list_eval (env, cond->iffalse);
}

void
rule_eval (struct eval_env *env, RC_RULE *rule)
{
  if (node_eval (env, rule->node))
    stmt_list_eval (env, rule->stmt);
}

void
stmt_list_eval (struct eval_env *env, RC_STMT *stmt)
{
  for (; stmt; stmt = stmt->next)
    {
      env->loc = stmt->loc;
      
      switch (stmt->type) {
      case rc_stmt_asgn:
	asgn_eval (env, &stmt->v.asgn);
	break;
	
      case rc_stmt_cond:
	cond_eval (env, &stmt->v.cond);
	break;
	
      case rc_stmt_rule:
	rule_eval (env, &stmt->v.rule);
	break;
	
      case rc_stmt_inst:
	inst_eval (env, &stmt->v.inst);
      }
    }
}

void
eval_section (int method, RC_SECTION *sec, struct rc_secdef *secdef,
	      void *data, MESSAGE *msg)
{
  struct eval_env env;
  env.method = method;
  env.child = secdef->child;
  env.refcnt = 0;
  env.refstr = NULL;
  env.msg = msg;
  env.data = data;
  env.loc = sec->loc;
  env.traceable = secdef->allow_prog;
  
  if (env.traceable)
    tracefile (&sec->loc, _("Section %s"), sec->name);
  
  if (setjmp (env.jmp) == 0)
    stmt_list_eval (&env, sec->stmt);
  
  if (env.refstr)
    xfree_pptr (env.refstr);
}	

void
rc_run_section (int method, RC_SECTION *sec, struct rc_secdef *secdef,
		void *data, MESSAGE *msg)
{
  if (!sec)
    return;

  for (; secdef->name; secdef++)
    {
      if (!strcmp (sec->name, secdef->name))
	{
	  eval_section (method, sec, secdef, data, msg);
	  return;
	}
    }
  anubis_error (0, 0, _("Unknown section: %s"), sec->name);
}

void
rc_call_section (int method, RC_SECTION *sec, struct rc_secdef *secdef,
		 void *data, MESSAGE *msg)
{
  if (!sec)
	  return;

  for (; secdef->name; secdef++)
    {
      if (!strcmp (secdef->name, "RULE"))
	{
	  eval_section (method, sec, secdef, data, msg);
	  return;
	}
    }
}

void
rc_run_section_list (int method, RC_SECTION *sec,
		     struct rc_secdef *secdef)
{
  for (; sec; sec = sec->next)
    rc_run_section (method, sec, secdef, NULL, NULL);
}

static int
check_kw (char *ident, int *flags)
{
  struct rc_secdef *p = rc_secdef;
  int key;
  
  if (!p)
    p = anubis_find_section ("RULE");
  return rc_child_lookup (p->child, ident, CF_ALL, &key, flags) != NULL;
}

static int
is_prog_allowed (void)
{
  struct rc_secdef *p = rc_secdef;
  if (!p)
    p = anubis_find_section ("RULE");
  
  if (!p->allow_prog)
    parse_error (_("program is not allowed in this section"));
  return p->allow_prog;
}

